; Azimut Project
; Copyright (c) 2007 Philippe Coulombe
; All rights reserved


.386
.MODEL FLAT, STDCALL
OPTION CASEMAP:NONE


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


INCLUDELIB kernel32.lib
INCLUDELIB user32.lib

ExitProcess PROTO :DWORD
MessageBoxW PROTO :DWORD,:DWORD,:DWORD,:DWORD


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


NULL  EQU 0
FALSE EQU 0
TRUE  EQU 1


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


BStrData MACRO LabelName:REQ, Text:REQ
    lbl textequ <&LabelName>
    bypass = 0
    count = 0
    forc chr, <&Text>
        if bypass ne 0
            if '&chr' eq 'n'
                count = count + 2
            else
                count = count + 1
            endif
            bypass = 0
        elseif '&chr' eq "/"
            bypass = 1
        else
            count = count + 1
        endif
    endm
    align 4
    dword count
    forc chr, <&Text>
        if bypass ne 0
            if '&chr' eq '/'        ; // = slash
                lbl word '/'
            elseif '&chr' eq 'a'    ; /a = apostrophe or single quote
                lbl word "'"
            elseif '&chr' eq 'e'    ; /e = exclamation
                lbl word '!'
            elseif '&chr' eq 'n'    ; /n = new line
                lbl word 13,10
            elseif '&chr' eq 'p'    ; /p = percent
                lbl word '%'
            elseif '&chr' eq 'q'    ; /q = double quote
                lbl word '"'
            elseif '&chr' eq '{'    ; /{ = parenthese open
                lbl word '('
            elseif '&chr' eq '}'    ; /} = parenthese close
                lbl word ')'
            elseif '&chr' eq '['    ; /[ = chevron open
                lbl word '<'
            elseif '&chr' eq ']'    ; /] = chevron close
                lbl word '>'
            endif
            bypass = 0
            lbl textequ <>          ; prevent label redefinition
        elseif '&chr' eq "/"
            bypass = 1
        else
            lbl word '&chr'
            lbl textequ <>          ; prevent label redefinition
        endif
    endm
    word 0                          ; null char terminator
ENDM


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


@BStrSize MACRO LabelName:REQ, WithNull:REQ   ; Bytes
    mov eax, offset LabelName
    mov eax, dword ptr [eax-DWORD]
    add eax, eax
    if WithNull ne 0
        add eax, WORD
    endif
    exitm <eax>
ENDM


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


@BStrLength MACRO LabelName:REQ, WithNull:REQ   ; Characters
    mov eax, offset LabelName
    mov eax, dword ptr [eax-DWORD]
    if WithNull ne 0
        inc eax
    endif
    exitm <eax>
ENDM


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


.DATA

BStrData szCaption, <BSTR /[/aBStrData/a/]>
BStrData szText, <Isn/at it great ?/n/n/{ /q99/p sure it is /e/q /}>


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


.CODE

Main:

    mov ecx, @BStrLength(szText, FALSE)
    mov edx, @BStrSize(szText, TRUE)

    invoke MessageBoxW, NULL, addr szText, addr szCaption, NULL
    invoke ExitProcess, NULL

END Main


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

